//
//  PlayerViewController.swift
//  AmpIMASample
//
//  Created by Lopez Valenciano, Miguel on 11/14/17.
//  Copyright © 2017 Akamai. All rights reserved.
//

import UIKit
import AmpCore
import AmpIMA

class PlayerViewController: UIViewController {
    
    var ampPlayer: AmpPlayer!
    var imaManager: AmpIMAManager!
    
    let url = "http://devimages.apple.com/iphone/samples/bipbop/bipbopall.m3u8"
    
    let imaPreRoll = "https://pubads.g.doubleclick.net/gampad/ads?sz=640x480&iu=/124319096/external/ad_rule_samples&ciu_szs=300x250&ad_rule=1&impl=s&gdfp_req=1&env=vp&output=vmap&unviewed_position_start=1&cust_params=deployment%3Ddevsite%26sample_ar%3Dpreonly&cmsid=496&vid=short_onecue&correlator="
    
    let imaPreMidPost = "https://pubads.g.doubleclick.net/gampad/ads?sz=640x480&iu=/124319096/external/ad_rule_samples&ciu_szs=300x250&ad_rule=1&impl=s&gdfp_req=1&env=vp&output=vmap&unviewed_position_start=1&cust_params=deployment%3Ddevsite%26sample_ar%3Dpremidpost&cmsid=496&vid=short_onecue&correlator="
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.createPlayer()
        
        // Instantiate the IMA Manager after our player is created
        self.imaManager = AmpIMAManager(ampPlayer: self.ampPlayer, videoView: self.ampPlayer.PlayerView!)
        self.imaManager.registerObserver(self)
    }
    
    func createPlayer() {
        if self.ampPlayer == nil {
            
            self.ampPlayer = AmpPlayer(parentView: self.view)
            self.ampPlayer.setLicense("AwEzOKGS83/8GuGyzd+nIXhKyrlrLX/MRXr3AEe6rr2hg0cmXc1ndKJCdAl4EF7TrfOQDcG+98edjS8EXZI7Rl6QdUkEsB3AKLyk5FRH39NLayvFntEB1yjqiar9njuYjCvazaV8OPprvGgtbtaIWr1nd7W7bn0ZqdB8j/A3V949Y8yPwhSB+LXZ+m9w38DYJWnaSnOKyPGGgj8qJRWmTZj+vDf5PhemzStvOLRAgV0Gnw==")
            
            // Register
            self.ampPlayer.registerObserver(self)
            
            let times = [2.0, 4.0, 6.0, 8.0]
            _ = CuepointManager(ampPlayer: self.ampPlayer, observer: self, times: times)
            
            self.ampPlayer.handleUrl(url)
            self.ampPlayer.autoplay = true
        }
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override open func viewWillDisappear(_ animated:Bool) {
        if (self.isMovingFromParentViewController) {
            self.ampPlayer.stop()
            self.ampPlayer = nil
            print("Stopped")
        }
        super.viewWillDisappear(animated)
    }
}

extension PlayerViewController : PlayerEventObserver {
    
    func onPlaybackStateChanged(_ ampPlayer: AmpPlayer) {
        //        print("onPlaybackStateChanged")
    }
    
    func onPositionChange(_ ampPlayer: AmpPlayer) {
        print("time: %d", ampPlayer.currentTime())
    }
    
    func onCuepointReached(_ ampPlayer: AmpPlayer, atTime: Double) {
        print("cuepoint:  \(atTime) - time:\(ampPlayer.currentTime())")
    }
}

extension PlayerViewController : IMAEventObserver {
    
    func onIMASetup(_ imaManager: AmpIMAManager) {
        self.imaManager.requestAds(assetkey:"sN_IYUG8STe1ZzhIIE_ksA")
        //self.imaManager.requestAds(adsUrl: imaPreMidPost)
        // live sN_IYUG8STe1ZzhIIE_ksA
        //        self.imaManager.requestAds("sN_IYUG8STe1ZzhIIE_ksA")
        //        self.imaManager.requestAds("sN_IYUG8STe1ZzhIIE_ksA", companionView: nil, contentSourceID: "19463", videoID: "googleio-highlights")
    }
    
}
